/**
 * 作者：dailc 
 * 时间：2016-01-21 11:10:25
 * 描述：  本地文件下载示例,有进度条监听
 */
(function() {
	var DownloadUtil = require('scripts/Core/DownLoadUtil.js');
	var fileUrl = 'http://vod1.yiihuu.com/vod/video_mp4/chuangyi/270408/fc8e26dd14e5fdeff21989ed85da3b03-sd-125192.mp4';
	Zepto('#clearFileLocalCache').on('tap', function() {
		Zepto('#fileName').text('无');
		DownloadUtil.clearNetUrlFileCache(fileUrl, function() {
			console.log('清除文件本地缓存成功!');
		}, function(e) {
			console.log('清除文件本地缓存失败!' + e);
		});
	});
	Zepto('#downloadFileWithCache').on('tap', function() {
		downloadFile(true);
	});
	Zepto('#downloadFileWithOutCache').on('tap', function() {
		downloadFile(false);
	});

	function downloadFile(IsWithCache) {
		var showProgressbar = null;
		var isCompleted = false;
		DownloadUtil.downloadFileWidthLocalCache(fileUrl, {
			beforeDownload: function() {
				console.log('准备开始上传');
				showProgressbar = plus.nativeUI.showWaiting('准备开始上传', {
					back: "close",
					padlock: true
				});
				showProgressbar.onclose = function() {
					//console.log('关闭下载...IsAbortDownload:'+IsAbortDownload);
					if (isCompleted == false) {
						DownloadUtil.abortTaskByUrl(fileUrl);
						//DownloadUtil.abortAllTask();
					}
				};
			},
			successDownload: function(relativePath) {
				isCompleted = true;
				if (showProgressbar) {
					showProgressbar.close();
				}
				console.log('下载成功:' + relativePath);
				Zepto('#fileName').text(relativePath);
			},
			errorDownload: function(msg) {
				isCompleted = true;
				if (showProgressbar) {
					showProgressbar.close();
				}
				Zepto('#fileName').text('下载失败:' + msg);
			},
			downloading: function(progress, tips) {
				console.log('下载进度为:' + progress + '%,' + tips);
				if (showProgressbar) {
					showProgressbar.setTitle(parseInt(progress) + "%," + tips);
				}
			}
		}, IsWithCache);
	};
})();